/* $Id: pe_rules.h,v 1.1 2005/03/31 16:29:35 andrew Exp $ */
/* 
 * Copyright (C) 2004 Andrew Beekhof <andrew@beekhof.net>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef PENGINE_RULES__H
#define PENGINE_RULES__H

/* do NOT free the nodes returned here */
extern GListPtr apply_node_expression(
	const char *attr, const char *op, const char *value,
	const char *type, GListPtr node_list);


extern gboolean test_node_attr_expression(
	const char *attr, const char *op, const char *value,
	const char *type, node_t *node);

extern gboolean test_resource_attr_expression(
	const char *attr, const char *op, const char *value,
	const char *type, resource_t *rsc);

extern gboolean coloc_expression(
	const char *attr, const char *op, const char *value,
	const char *type, node_t *node);

extern gboolean loc_expression(
	const char *attr, const char *op, const char *value,
	const char *type, node_t *node);

extern gboolean attr_expression(
	const char *attr, const char *op, const char *value,
	const char *type, GHashTable *hash);


#endif
